PROCEDURE create_grid_Define

************************************************************
* Tabla: <CLIENTES>
************************************************************
* "IDCLIEN","C",5,0,
* "CODIGO","C",5,0,
* "NOMBRE","C",40,0,
* "CUIT","C",13,0,
* "DNI","C",10,0,
* "TIPODOC","C",2,0,
* "NRENTAS","C",24,0,
* "CALLE","C",25,0,
* "NUMERO","C",10,0,
* "PISO","C",5,0,
* "DEPTO","C",5,0,
* "OFICINA","C",5,0,
* "CPOSTAL","C",4,0,
* "CIUDAD","C",30,0,
* "CODPROVIN","C",1,0,
* "PROVINCIA","C",24,0,
* "TELEF1","C",16,0,
* "TELEF2","C",16,0,
* "LINEAFAX","C",16,0,
* "CELULAR","C",18,0,
* "NUMPROV","C",10,0,
* "EMAIL","C",40,0,
* "TIPIVA","C",1,0,
*************************


*!*  ----------------------------------------------------------------------------------------------------------
*!*		Acá se presenta una versión prácticamente mínima de un control grid. ;
*!*		El objetivo es simplemente mostrar cómo se puede estandarizar e implementar ;
*!*		fácilmente a través de clases. ;
*!*		;
*!*		Este procedimiento debería ser reemplazado por una clase (por ejemplo "custom") ;
*!*		que tenga definidas todas las propiedades y en la cual se puedan efectuar ;
*!*		las definiciones utilizadas por Default. ;
*!*		A su vez, la clase custom se puede pegar al formulario en el que se utilice ;
*!*		lo cual evita errores de ortografía ;
*!*		;
*!*		Para las pruebas, se deberá utilizar una tabla ya creada y modificar en este ;
*!*		procedimiento, por lo menos, el nombre de la tabla y sus campos ;
*!*		;
*!*		Con algunas modificaciones se puede utilizar el procedimiento para un form existente ;
*!*		Lo ideal es contar también con una clase basada en Grid y una clase basada en Form ; 
*!*		donde ya estén preconfiguradas las necesidades básicas y todo lo que queremos que se vea ;
*!*		como integrante del mismo estilo de programación ;
*!*  ----------------------------------------------------------------------------------------------------------
*!*		BindEvent() se puede utilizar con gran eficiencia para controlar algunas cuestiones en lugar de
*!*		colocar código en los objetos del grid (Header, Text1, etc)
*!*
*!*		En el control grid creado de esta forma, se pueden reemplazar los controles Text1 de las columnas 
*!*		por otros objetos (Check1, combobox, Text2, etc) según la funcionalidad que se necesite, para lo cual
*!*		es recomendable que los objetos estén preconfigurados para utilizar en grid en sus respectivas clases.
*!*
*!*		Cuando se necesita utilizar un control distinto del text1, se agrega el control necesario en la columna 
*!*		correspondiente y luego se actualiza la propiedad CurrentControl del grid al nombre del objeto agregado.
*!*  ----------------------------------------------------------------------------------------------------------	
*!*		Nota: El formulario que se crea en este ejemplo podrá ser liberado desde cualquier punto con lo siguiente:
*!*			IF PEMSTATUS(_screen,"frm_NewGrid",5) ;
*!*				AND VARTYPE(_screen.Frm_newgrid)="O"
*!*				_screen.frm_newgrid = null
*!*			ENDIF 
*!*  ----------------------------------------------------------------------------------------------------------		

TRY 

	LOCAL LOEX AS EXCEPTION,;
		loGrid AS OBJECT,;
		loForm as Object,;
		LCMESSAGE
		
	*<Creación de un cursor>
	SELECT *,.f. as incluye,CAST(0 as N(12,2)) as Valor ;
		FROM clientes ;
		WHERE .t. ;
		INTO CURSOR curClientes READWRITE  	
		
	*<Grid>
	loGrid = NEWOBJECT("Empty")
	ADDPROPERTY(loGrid,"cursor_name","curclientes")								&& Nombre del cursor o tabla que se mostrará

	ADDPROPERTY(loGrid,"Font_Name","Arial")										&& Nombre de la fuente
	ADDPROPERTY(loGrid,"Font_Size",8)											&& Tamaño de la fuente
	ADDPROPERTY(loGrid,"lAllowCellSelection",.t.)								&& Si se pueden seleccionar las celdas
	ADDPROPERTY(loGrid,"lDeleteMark",.f.)										&& Si tiene la marca de borrado visible
	ADDPROPERTY(loGrid,"lRecordMark",.t.)										&& Si muestra el puntero de registro
	ADDPROPERTY(loGrid,"grid_ScrollBars",2)										&& Configuración de barra horizontal y vertical
	
	ADDPROPERTY(loGrid,"List_column","nombre|cuit|idclien|ciudad|Monto|Memorias|Incluye")	&& campos del cursor que se quiere mostrar
	ADDPROPERTY(loGrid,"List_Header","Cliente|Cuit|Id_|Ciudad|Crédito|Observa|Inc")		&& Header de los campos mostrados
	ADDPROPERTY(loGrid,"List_Width","200|92|60|180|90|120|24")						&& Ancho concedido a los Campos
	ADDPROPERTY(loGrid,"List_Align","0|0|0|0|2|0|2")								&& Align del Header
	
	ADDPROPERTY(loGrid,"grid_top",3)											&& posición Top del grid en el form
	ADDPROPERTY(loGrid,"grid_left",3)											&& posición Left del grid en el form

	ADDPROPERTY(loGrid,"grid_rowHeight",18)										&& Alto de las filas
	ADDPROPERTY(loGrid,"grid_nRows",20)											&& Cantidad de filas que se muestran
	ADDPROPERTY(loGrid,"grid_Autowidth",.t.)									&& Si el ancho del grid (width) se autoconfigura


	*</Grid>	
	
	*<Form>
	loform = NEWOBJECT("Empty")
	ADDPROPERTY(loForm,"Form_name","frm_NewGrid")								&& Nombre del form
	ADDPROPERTY(loForm,"Form_Caption","Consulta de Clientes")					&& Caption del form
	ADDPROPERTY(loForm,"Form_top",5)											&& posición del form en _screen
	ADDPROPERTY(loForm,"Form_left",5)											&& posición del form en _screen
	ADDPROPERTY(loform,"Form_WindowType",0)										&& Si el form será modal o modeless
	ADDPROPERTY(loForm,"Form_AlwaysOnTop",.f.)									&& Si el form se mostrará por encima de otros forms
	*</Form>	
	
	*<Raise>
	create_Grid_create(loForm,loGrid)
	*</Raise>		
	
CATCH TO LOEX
	LOEX.USERVALUE = PROGRAM()
	SHOW_ERROR(LOEX)

FINALLY
	loGrid = null
	loForm = null
	IF !EMPTY(LCMESSAGE)
		Messagebox(M.LCMESSAGE,0,PROPER(PROGRAM()))
	ENDIF


ENDTRY

PROCEDURE create_Grid_create
*-----------------------------
LPARAMETERS toForm,toGrid
TRY 

	LOCAL LOEX AS EXCEPTION,;
		LCMESSAGE,;
		lofrm as Object,;
		loGrd as Object,;
		lcFormName,;
		lnColumns,;
		i,;
		lnWidth,;
		lnFields,;
		lcField,;
		lnAScan,;
		lcType,;
		lnLen,;
		lnDec,;
		lcControlSource		
	
	
		
	DO WHILE .t.
		IF VARTYPE(toForm)#"O" ;
			OR VARTYPE(toGrid)#"O"
			lcMessage = "Error en parámetros"
			EXIT
		ENDIF
		
		LOCAL ARRAY laFields(1)
		
		lnFields = AFIELDS(laFields,toGrid.Cursor_name)
		
		*<crea_formulario>
		
		lcFormName = toForm.Form_name
		ADDPROPERTY(_screen,m.lcFormName,null)
		
		_screen.&lcFormName = CREATEOBJECT("Form")
		loFrm = _screen.&lcFormName.
		
		WITH loFrm
			.Top = toForm.Form_top 
			.left = toForm.Form_left
		ENDWITH 
		
		*<crea_objeto_Grid>
		
		IF !PEMSTATUS(loFrm,"Grilla",5)
			loFrm.AddObject("Grilla","Grid")
		ENDIF 
		IF !PEMSTATUS(loFrm,"Grilla",5)
			lcMessage = "No se pudo crear el objecto Grilla"
			EXIT
		ENDIF 

		loGrd = loFrm.Grilla
		
		lnColumns = GETWORDCOUNT(toGrid.List_column,CHR(124))
		WITH loGrd
			.themes = .f.
			.top = toGrid.grid_top
			.left = toGrid.grid_left
			.ColumnCount = -1
			.ColumnCount = m.lnColumns
			.RecordSource = ""	
			.RecordSource = toGrid.Cursor_name				
			.RowHeight = EVL(toGrid.grid_rowHeight,18)
			.deleteMark = toGrid.lDeleteMark
			.RecordMark = toGrid.lRecordMark
			.ScrollBars = toGrid.grid_ScrollBars
			
			.SetAll("FontName",EVL(toGrid.Font_Name,"Arial"),"Column")
			.Setall("Fontsize",EVL(toGrid.Font_Size,8),"Column")	

			.SetAll("FontName",EVL(toGrid.Font_Name,"Arial"),"Header")				
			.Setall("Fontsize",EVL(toGrid.Font_Size,8),"Header")
			.Setall("FontBold",.t.,"Header")			
			.Setall("BackColor",Rgb(73,136,160),"Header")
			.Setall("ForeColor",Rgb(255,255,255),"Header")			

			.AllowCellSelection = IIF(VARTYPE(toGrid.lAllowCellSelection)="L",;
				toGrid.lAllowCellSelection,;
				.t.)
		
		ENDWITH 
		
		
		FOR i = 1 TO m.lnColumns
			lcField = GETWORDNUM(toGrid.List_column,i,CHR(124))
			lnAscan = ASCAN(lafields,m.lcField,1,0,0,7)
			lcType = laFields[m.lnAscan + 1]
			lnLen = laFields[m.lnAscan + 2]
			lnDec = laFields[m.lnAScan + 3]
			lcControlSource = toGrid.Cursor_Name + CHR(46) + m.lcField
			
			WITH loGrd.Columns(i)
				.Header1.Caption = " "+GETWORDNUM(toGrid.List_Header,i,CHR(124))
				.Header1.Alignment = VAL(GETWORDNUM(toGrid.List_Align,i,CHR(124)))
				.InputMask = ""
				.Format = ""	
				.width = VAL(GETWORDNUM(togrid.List_width,i,CHR(124)))					
			*	.ControlSource = toGrid.Cursor_Name + "." + m.lcField
				DO CASE 
					CASE m.lcType = "N"
				
						.InputMask = Det_Mask(m.lnLen,m.lnDec)
						.format = "Z"
						.ControlSource = m.lcControlSource	
					
					CASE m.lcType = "I"
						.InputMask = "9999999"
						.ControlSource = m.lcControlSource						
					CASE m.lcType = "L"
						.ControlSource = m.lcControlSource
						.Sparse = .f.						
						IF PEMSTATUS(loGrd.Columns(i),"Check1",5)
							loGrd.Columns(i).RemoveObject("Check1")
						ENDIF 
						.AddObject("Check1","Checkbox")
						.CurrentControl = "Check1"
						.Check1.Caption = ""
						.Check1.Centered = .t.
						.Check1.Visible = .t.
						
					CASE m.lcType = "M"
						.ControlSource = m.lcControlSource
						.Sparse = .f.
						IF PEMSTATUS(loGrd.Columns(i),"Edit1",5)
							loGrd.Columns(i).RemoveObject("Edit1")
						ENDIF 
						.AddObject("Edit1","Editbox")
						.Edit1.BackStyle = 0
						.Edit1.BorderStyle = 0
						.Edit1.SpecialEffect = 1
						.CurrentControl = "Edit1"
						.Edit1.Visible = .t.
					OTHERWISE 
						.ControlSource = m.lcControlSource
				ENDCASE 

			ENDWITH 

		NEXT 
		
	
				

		loFrm.Grilla.Width = create_Grid_WidthGrid(loFrm.Grilla)

		loFrm.Grilla.Height = loFrm.Grilla.HeaderHeight ;
			+ toGrid.grid_nRows * toGrid.grid_rowHeight + 2
		
		WITH loFrm
			.Caption = toForm.Form_Caption
			.Height = .Grilla.top * 2 + .grilla.Height
			.Width = .grilla.Left * 2 + .grilla.Width
			.Grilla.Visible = .t.
			.AlwaysOnTop = toForm.form_AlwaysOnTop
			.Name = toForm.form_Name
			.MinHeight = .Grilla.top * 2 + .grilla.HeaderHeight + toGrid.Grid_RowHeight * 2 
			.MaxHeight = SYSMETRIC(2) - ;
				(SYSMETRIC(4) + SYSMETRIC(9) + SYSMETRIC(34) + .top + 80)
		
			.minwidth = .width 
			.Maxwidth = .width 
			
			.Grilla.Anchor = 15
		ENDWITH 
		loFrm.Show(toForm.Form_WindowType)	
		EXIT 
	ENDDO
	

	
CATCH TO LOEX
	LOEX.USERVALUE = PROGRAM()
	SHOW_ERROR(LOEX)

FINALLY
	toForm = null
	toGrid = null
	loFrm = null
	IF !EMPTY(LCMESSAGE)
		Messagebox(M.LCMESSAGE,0,PROPER(PROGRAM()))
	ENDIF

ENDTRY

PROCEDURE create_Grid_WidthGrid
* -----------------------------
* Determina el ancho de un grid
* según sus características
* -----------------------------
LPARAMETERS toGrid
TRY 
	LOCAL loex as Exception,;
		lnWidth,lnSumWidth,;
		i
		
	lnW = 1		
	lnSysOp = get_sysOp()	
	lnSumWidth = 0	
	lnWidth = 0

	IF VARTYPE(toGrid)="O"
		FOR i = 1 TO toGrid.ColumnCount
			lnSumWidth = m.lnSumWidth + toGrid.Columns(i).Width 
		NEXT 
		
		
		lnWidth = lnSumWidth ;
			+ toGrid.ColumnCount ;
			+ IIF(toGrid.RecordMark,10,1) ;
			+ IIF(toGrid.ScrollBars > 1,SYSMETRIC(5),0) ;
			+ IIF(toGrid.AllowCellSelection,0,1) ;
			+ 2 ;
			+ 1 ;
			+ 1

	ENDIF 

CATCH TO loex
	loex.UserValue = PROGRAM()
	Show_Error(loex)

FINALLY
	toGrid = null
ENDTRY
RETURN m.lnWidth
ENDPROC 

PROCEDURE DET_MASK
*!*	-------------------------------------------------------------------------
*!*	Determina un InputMask (máscara de formato numérico)
*!*	tnEnteros		Cantidad de dígitos enteros
*!*	tnDecimals		Cantidad de decimales
*!*	tnlenFormat		Variable pasada por referencia devuelve el LEN() del formato
*!*	tnlimit			Se puede ingresar un maximo de enteros (15 Default)
*!*	-------------------------------------------------------------------------
LPARAMETERS tnEnteros,tnDecimals,tnLenFormat,tnLimit
TRY 

	LOCAL LOEX AS EXCEPTION,;
		LCMESSAGE,;
		lcFormato,i_,lnResto,lnRepeti,lnDigit
		
	lcFormato=""
	tnLenFormat=0

	tnLimit = EVL(m.tnLimit,15)
	tnEnteros = MIN(m.tnEnteros,m.tnLimit)
	lnDigit = m.tnEnteros - IIF(EMPTY(m.tnDecimals),0,m.tnDecimals+1)
	lnRepeti = INT(m.lnDigit/3)
	lnResto = MOD(m.lnDigit,3)
	lcFormato = REPLICATE("9",m.lnResto)+IIF(m.lnResto=0,"",",")
	For i_=1 to m.lnRepeti
		lcFormato = m.lcFormato+"999"+IIF(m.i_ < m.lnRepeti , CHR(44) ,"")
	NEXT
	IF RIGHT(m.lcFormato,1) = CHR(44)
		lcFormato = LEFT(m.lcFormato,LEN(m.lcFormato) - 1 )
		
	ENDIF
	lcFormato = m.lcFormato + IIF(m.tnDecimals = 0,"",".")+REPLICATE("9",m.tnDecimals)
	tnLenFormat = LEN(m.lcFormato)
CATCH TO LOEX
	LOEX.USERVALUE = PROGRAM()
	SHOW_ERROR(LOEX)

FINALLY
ENDTRY

RETURN lcFormato
ENDPROC 


*----------------------------------------------------
PROCEDURE Show_Error
LPARAMETERS toExcep,tlNotShow,tcCaption
*-----------------------------------------------------
tcCaption=EVL(tcCaption,"Mensaje del Sistema")
SET HOURS TO 24
LOCAL lcMens


lcMens="Fecha "+TRANSFORM(DATETIME());
	+ Chr(13)+"Mensaje: "+toExcep.message;
	+ Chr(13)+"ErrorNo: "+TRANSFORM(toExcep.Errorno);
	+ Chr(13)+"Llamada: "+toExcep.Uservalue
IF _vfp.StartMode=0
	lcMens=lcMens+ Chr(13)+"Linea "+TRANSFORM(toExcep.lineno)
ENDIF

STRTOFILE(lcMens+ Chr(13)+REPLICATE("=",60)+ Chr(13),"Errors.log",1)

lcMens="Se ha producido un error:"+ Chr(13)+lcMens
IF !tlNotShow
	MESSAGEBOX(m.lcMens,0,m.tcCaption)
ENDIF

ENDPROC
